// if you use separate libs, you need to copy all of them to /dtv/ directory.!
// #define COPY_DTV_LIBS 

#include <stdarg.h>

#if defined(WIN)
#include "SDL.h"
#include "SDL_ttf.h"
#include "SDL_image.h"
#include <windows.h>
#else

#include <dirent.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <pthread.h>
#include <netdb.h>
#include <unistd.h>
#include <dlfcn.h>
#include <assert.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>      



#include <stdio.h>     
#include <netdb.h>     
#include <string.h>    
#include <sys/types.h> 
#include <sys/socket.h>

#endif


#define THUMB_DISPLAY_MAX  	20
#define THUMB_ITEM_X  			5
#define THUMB_ITEM_Y  			4


typedef int (*func)(char *, char *);


static int	nItemIndexX = 0;
static int	nItemIndexY = 0;
static int	nItemIndex = 0;
static unsigned short	nItemRealIndex = 0;

static int	nTotalLineCount = 0;
static char	nCurrentLineMax = THUMB_ITEM_X;
static unsigned char	nCurrentPageCount = 0;
static unsigned int	nCurrentPage = 0;
static unsigned int	nCountOfPage = 0;



SDL_Event event;
SDL_Rect dstrect;
SDL_Surface *screen,*btsu,* bg,* temp;

static char				main_path[0xff];
char sel_icon[0xff];

static unsigned int 	widget_count = 0;
void listdir(char * directory );

typedef struct {

	char		id[30];
	char		name[100];
	char		normal[255];
	char		focus[255];
	char		path[0xFF];

} widget_struct_t;

widget_struct_t widgets[200];  // maybee tlist later to be done!

TTF_Font *font14;
TTF_Font *font24;

static int count = 0;

void mcas_debug(const char *format, ...)
{
	char String_p[1024] = "";
	FILE * logfile;
	va_list	arguments;
	#if defined (ARM7)
	char file[1024];
	sprintf(file, "%s/game_log.txt", main_path);
	logfile = fopen(file, "a+");
	#else
	logfile = fopen("/mnt/hgfs/samlinux/module_game.txt", "a+");
	#endif
	va_start(arguments, format);
	vsprintf(String_p, format, arguments);
	va_end(arguments);
	#if defined(WIN)
	OutputDebugString(string);
	#endif	
	if (logfile) {
		fprintf(logfile, "%s", String_p );
		fclose(logfile);
	}
}

void CleanUp(void)
{
	if (font14) TTF_CloseFont(font14);
   if (font24) TTF_CloseFont(font24);
	TTF_Quit();
   SDL_Quit();
}

void sdl_draw_text(int x, int y, char *msg, int len_cut)
{
	char tempstr[100];
	
	memset(tempstr, 0, 100);
	
	if (len_cut) 
		strncpy(tempstr,msg, len_cut);
	else 
		strcpy(tempstr,msg);
	int width = 10, height = 10, n = 0,w = 0;
	TTF_SizeText( font14, tempstr, &w,&height );
	SDL_Color c_black={ 0, 0, 0 };
	SDL_Color c_yellow={ 255, 255, 0 };
	SDL_Rect dstrect = { x + width/2-w/2, y, 0, 0 };

	btsu=TTF_RenderText_Solid(font14, tempstr ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
}

void sdl_draw_text24(int x, int y, char *msg)
{
	int width = 10, height = 10;
	int n = 0;
	int w = 0;
	TTF_SizeText( font24, msg, &w,&height );
	SDL_Color c_black={ 0, 0, 0 };
	SDL_Color c_yellow={ 255, 255, 0 };
   
	SDL_Rect dstrect = {x + width/2-w/2, y, 0, 0 };


	btsu=TTF_RenderText_Solid(font24, msg ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
}

void sdl_draw_text_1(int x, int y, char *msg, int len_cut)
{
   
	int width = 10, height = 10;
	int n = 0;
	int w = 0;
	char tempstr[100];
	
	memset(tempstr, 0, 100);
	if (len_cut) 
		strncpy(tempstr,msg, len_cut);
	else 
		strcpy(tempstr,msg);
		
	TTF_SizeText( font14, tempstr, &w,&height );
	SDL_Color c_black={ 0, 0, 0 };
	SDL_Color c_yellow={ 1, 1, 0 };
	SDL_Rect dstrect = { x + width/2-w/2, y, 0, 0 };
	btsu=TTF_RenderText_Solid(font14, tempstr ,  c_yellow);
	SDL_BlitSurface(btsu, NULL, screen, &dstrect);
	SDL_FreeSurface(btsu);  
}
/*
	<ThumbIcon>icon/samy106x87.png</ThumbIcon>
	<BigThumbIcon>icon/samy115x95.png</BigThumbIcon>
*/

void game_read_config_dir(void) {
	
	FILE *inputfp;	
	char file[1024], b[2056],dir[1024],*start,*end  ;
			
	sprintf(file, "%s/config.xml", main_path);
	inputfp  = fopen( file , "r");
	if (inputfp) {
		while (fgets(b, sizeof(b), inputfp)) {
			mcas_debug("fgets b = %s\n", b);
			memset(dir, 0, sizeof(dir));
			if (strstr(b, "<dir>") )  {
				start = strstr(b, "<dir>");
				end =   strstr(b, "</dir>");
				memcpy(dir,start + 5, (end - start) - 5); 
				memset(b, 0, sizeof(b));
				listdir(dir);
			}
			
		}
		fclose(inputfp);
	} else {
		listdir("/mtd_rwcommon/GGame");
	} 
}
/*
collect widget informations from config.xml!
*/
void widget_config(char *file, char *directory) {
	
	FILE *inputfp;	
	char b[2056], rc;
	char tmp[0xFF];
	char tempfile[0xFF];
	char cmd[1024];

	sprintf(tempfile, "%s/config.xml", file);
	inputfp  = fopen( tempfile , "r");
	if (inputfp) {
		while (fgets(b, sizeof(b), inputfp)) {
			char *start;
			char *end  ;
			memset(tmp, 0, sizeof(tmp));
			if (strstr(b, "<widgetname>"))  {
				start = strstr(b, "<widgetname>");
				end =   strstr(b, "</widgetname>");
				memcpy(widgets[widget_count].name,start + 12, (end - start) - 12); 
			}else if (strstr(b, "<ThumbIcon>"))  {
				start = strstr(b, "<ThumbIcon>");
				end =   strstr(b, "</ThumbIcon>");
				memcpy(tmp ,start + 11, (end - start) - 11);
				sprintf(widgets[widget_count].normal , "%s/%s",file , tmp);
				sprintf(widgets[widget_count].path , "%s",file);
			}else if (strstr(b, "<BigThumbIcon>"))  {
				start = strstr(b, "<BigThumbIcon>");
				end =   strstr(b, "</BigThumbIcon>");
				memcpy(tmp ,start + 14, (end - start)- 14);
				sprintf(widgets[widget_count].focus , "%s/%s",file , tmp);
			}
		}
		fclose(inputfp);
	}
	widget_count++;

	return;
}

void listdir(char * directory ) {
	
	struct stat FileInfo;
	char name[1024];
	struct stat dirinfo;
	struct dirent * files;
	DIR * dirin;

	if (lstat(directory, &dirinfo) < 0) {
		perror (directory);
		return;
	}
	if (!S_ISDIR(dirinfo.st_mode))	{
		perror(directory);
		return;
	}
	if ((dirin = opendir(directory)) == NULL) {
		perror(directory);
		return;
	}
	while ((files = readdir(dirin)) != NULL) {
		sprintf(name, "%s/%s", directory, files -> d_name);
      mcas_debug("%s\n",name); 
		if (strstr(name,"config.xml"))   {
			widget_config(directory, "  " );
		}
		if (lstat(name, &FileInfo) < 0) perror(name);
		if ( S_ISDIR( FileInfo.st_mode ) && strcmp(files -> d_name, ".") != 0 && strcmp(files -> d_name, "..") != 0 ) {
			listdir(name );
		} else if ( strcmp(files -> d_name, ".") != 0 && strcmp(files -> d_name, "..") != 0 ) {
          // printf("%s\n", name );
		}
	}
	closedir(dirin);
}

int sdl_init_all(char *path){

   char str[100];
   struct stat sts;
   int fsize;

	sprintf(str, "%s/res/shadow.ttf", path);
   if(stat(str, &sts) != 0){
		mcas_debug("error loading %s\n",str);
		return(1);
	}
	mcas_debug("SDL_Init\n");
   if(SDL_Init(SDL_INIT_VIDEO) != 0)	{
   	mcas_debug("error sdl init\n");
   	return(2);
   }
	mcas_debug("SDL_SetVideoMode\n");
#if defined (LINUX_SIM)
	screen=SDL_SetVideoMode(1920/2, 1080/2, 32, 0);
#else
   screen=SDL_SetVideoMode(1920/2, 1080/2, 32, SDL_HWSURFACE );
#endif
   mcas_debug("SDL_SetVideoMode return\n");
   if(screen == NULL){
      mcas_debug("error screen\n");
      return(3);
	}
	mcas_debug("TTF_Init & TTF_OpenFont\n");
   if((TTF_Init() != 0) || ((font14=TTF_OpenFont(str, 14)) == NULL) || ((font24=TTF_OpenFont(str, 24)) == NULL)) {
		 mcas_debug("error TTF_Init\n");
		SDL_Quit();
		return(4);
	}

	sprintf(str, "%s/res/main_bg.png", path);
	mcas_debug("IMG_Load %s\n", str);
	temp = IMG_Load(str);
	if (temp) {
		mcas_debug("SDL_DisplayFormat\n");
		bg = SDL_DisplayFormat(temp);
	} else {
		mcas_debug("error loading bg.bmp\n");
 		CleanUp();
		return (5);	
	}
	sprintf(sel_icon,"%s/res/widget_on_bg.png", path); 
	mcas_debug("SDL_FreeSurface\n");
	SDL_FreeSurface(temp);
	mcas_debug("SDL_BlitSurface\n");
	SDL_BlitSurface(bg, NULL, screen, NULL);
	SDL_Flip(screen);
	
	sdl_draw_text24(1920/4,20 , "SamyGO@TV");

	sdl_draw_text(1920/4,250 , "Colecting Info, Please wait...",0);
	SDL_Flip(screen);
	SDL_BlitSurface(bg, NULL, screen, NULL);
	if(widget_count == 0) game_read_config_dir();
   
   nTotalLineCount = widget_count/THUMB_ITEM_X;
	disp_sc_info_view(0);	
	SDL_Flip(screen);
  	return 0;
}

int sdl_draw_bitmap(int xpos, int ypos, const char *pngname, int enlarge)
{
   SDL_Surface *image = IMG_Load ( pngname );
   if ( !image )
   {
      mcas_debug ( "IMG_Load: %s\n", IMG_GetError () );
      return 1;
   }
   SDL_Rect rcDest = { xpos, ypos, 0,0 };
   SDL_BlitSurface ( image, NULL, screen, &rcDest );


   SDL_UpdateRect(screen, xpos, xpos, image->w, image->h);
   SDL_FreeSurface ( image );
   return 0;
}

void InitValue( void ){
	
	nItemIndexX = 0;
	nItemIndexY = 0;
	nItemIndex = 0;
	
	nTotalLineCount = 0;
	nCurrentLineMax = THUMB_ITEM_X;
	
	nCountOfPage = 0;
	nCurrentPage = 0;
}


void disp_sc_info_view(unsigned int index) {
	
	char string[100],icon [0xff],cointstr[20];
	int i, n = 0,x = 0,y = 0, nStartIndex, nEndIndex;
	int bx = -1, by= -1;
	int z = 20; int z1 = 20;int xs = 135;
	index = nItemIndexX +(nItemIndexY*THUMB_ITEM_X) + (nCurrentPage*THUMB_DISPLAY_MAX);
	
	sdl_draw_text24(1920/4,20 , "SamyGO@TV");

	if(widget_count > THUMB_DISPLAY_MAX) {
		nCountOfPage = widget_count/THUMB_DISPLAY_MAX + 1;
	} else {
		nCountOfPage = 1;
	}

	nTotalLineCount =widget_count/THUMB_ITEM_X;
	nCurrentPageCount = 0;

	nStartIndex = nCurrentPage*THUMB_DISPLAY_MAX;
	nEndIndex = (nCurrentPage+1)*THUMB_DISPLAY_MAX;
	if (nEndIndex >= widget_count) {
		nEndIndex = widget_count;
	}
	for( i=nStartIndex; i<nEndIndex; i++, n++) {
		int nDivIndex = i % THUMB_DISPLAY_MAX;

		sprintf(cointstr, "%d/%d", index+1 , widget_count);
		sdl_draw_text(1920/2 - 50,40 , cointstr, 0);
		if (index == i) {
			bx = x; by = y;
			
		} else { 
			sdl_draw_bitmap(xs +70 + x*120, 100 - z +  y *110, widgets[i].normal,  0);
			sdl_draw_text_1(xs +115+ x * 120, 190 - z + y *110,(char *) widgets[i].name, 15);
		}
		x++;
		if (x > THUMB_ITEM_X -1) {
			y++;
			x= 0;
		}
		nCurrentPageCount++;
	}
	if (bx != -1 && by!= -1) {
		sdl_draw_bitmap(xs +45 + bx*120, 80-z +  by *110, sel_icon,  0);
		sdl_draw_text(xs +115+ bx * 120, 195-z +  by *110,(char *) widgets[index].name, 15);
		sdl_draw_bitmap(xs +62 + bx*120, 92-z +  by *110, widgets[index].focus,  0);
	}
}

void LoadGame(unsigned int index) {

	void *dl_handle;

	char *error;
	char libfile[100];
	char cmd[0x1000];
	
	SDL_BlitSurface(bg, NULL, screen, NULL);
	sdl_draw_text24(1920/4,20 , "SamyGO@TV");
	#if defined (COPY_DTV_LIBS)
	sdl_draw_text(1920/4,250 , "Copy files...", 0);
	#endif
	SDL_Flip(screen);
	
											
	sprintf(libfile, "%s/game.so",widgets[index].path);
	#if defined (COPY_DTV_LIBS)
	sprintf(cmd, "cp %s/lib/*.so* /dtv/",widgets[index].path );
	system(cmd);
	mcas_debug("copy ok? Game_Main %s\n", cmd); 
	system("sync");
	#endif
	//system("ls -a /dtv/ > /dtv/usb/sda/dtvdir.txt");
	dl_handle = dlopen( libfile, RTLD_LAZY );
	if (!dl_handle) {
		mcas_debug( "!!! %s\n", dlerror() );
		#if defined (COPY_DTV_LIBS)
		sprintf(cmd, "rm -f /dtv/*.so",widgets[index].path );
		system(cmd);
		system("sync");
		#endif
		SDL_BlitSurface(bg, NULL, screen, NULL);
		sdl_draw_text24(1920/4,20 , "SamyGO@TV");
		sdl_draw_text(1920/4,250 , "Error...",0);
		SDL_Flip(screen);
		CleanUp();
		return;
	}
	SDL_BlitSurface(bg, NULL, screen, NULL);
	sdl_draw_text24(1920/4,20 , "SamyGO@TV");
	sdl_draw_text(1920/4,100 , "Run...",0);
	SDL_Flip(screen);
	CleanUp();
	
	void* tmpfunc = (void*)  dlsym( dl_handle, "Game_Main" );
	error = dlerror();
	if (error != NULL) {
		mcas_debug( "!!! %s\n", error );
		return;
	}
	assert(sizeof(func) == sizeof(tmpfunc));
	func tmp;
	memcpy(&tmp, &tmpfunc, sizeof(tmpfunc));
	
	/* Call the resolved method and print the result */
	mcas_debug("call Game_Main %x %s\n",tmp , widgets[index].path); 
	//system("export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/mtd_rwarea/lib");  //EABI 5 test for genoa games!
	
	tmp(widgets[index].path , " " );
	#if defined (COPY_DTV_LIBS)
	sprintf(cmd, "rm  /dtv/*.so*",widgets[index].path );
	sprintf(cmd, "rm  /dtv/*.so*",widgets[index].path );
	system(cmd);
	system("sync");
	#endif
	dlclose( dl_handle );
}

int Game_Main(const char *path,  char *udn )
{
	
   unsigned char gameRunning = 1;
	char str[100];
	char old_path[256];
	unsigned char rc = 0;
	
	strcpy(main_path, path);

	if (getcwd(old_path, sizeof(old_path)) == NULL) strcpy(old_path, "/mtd_exe/");
   chdir(path);
	mcas_debug("Game_Main Starting @ %s\n", path );
	chdir(path); //change path to current
	setenv("HOME", path, 1);
	widget_count = 0;
	InitValue();
	rc = sdl_init_all((char*) path );
	if (rc > 0) {
		mcas_debug ("Error SDL INIT %d\n", rc);
		chdir(old_path);
   	setenv("HOME", old_path, 1);
   	return 0;
	}
   while (gameRunning) {
      if (SDL_PollEvent(&event)) {
      	if (event.type == SDL_QUIT ) {
 				CleanUp();
			   return 0;
      	} 
      	if(event.type == SDL_KEYDOWN) {
         	switch (event.key.keysym.sym) {
					case SDLK_UP	:	SDL_BlitSurface(bg, NULL, screen, NULL);

											nItemRealIndex =  nItemIndexX +(nItemIndexY*THUMB_ITEM_X) + (nCurrentPage*THUMB_DISPLAY_MAX);
											if(nItemRealIndex < THUMB_ITEM_X ){ 
												nItemIndexX = 0;
												disp_sc_info_view( nItemRealIndex );
												break;
											}
											if(nTotalLineCount < 2) {
												break;
											}
											nItemIndexY--;
											if(nItemIndexY < 0) {
												nCurrentPage--;
												if(nCurrentPage < 0) {
													nCurrentPage = 0;
													nItemIndexY = 2;
												} else {
													nItemIndexY = THUMB_ITEM_Y -1;
												}
											}
											disp_sc_info_view( nItemRealIndex );
											SDL_Flip(screen);
						
											break;
					case SDLK_DOWN : 	SDL_BlitSurface(bg, NULL, screen, NULL);
											if(nTotalLineCount < 2) {
												break;
											}
											nItemIndexY++;
											if (nItemIndexY > THUMB_ITEM_Y-1) {
												nItemIndexY = 0;
												if(nCountOfPage > 1) {
													nCurrentPage++;		
													if(nCountOfPage < nCurrentPage+1) {
														nCurrentPage = 0;
													}
												}
											} else {
												int LineCount = nCurrentPageCount/THUMB_ITEM_X;
												if(nItemIndexY > LineCount-1) {
													nItemIndexY = 0;
													nCurrentPage = 0;
												}
											}
											if(nItemIndexY > nTotalLineCount-1) {
												nItemIndexY = 0;
											}
											nItemIndex =  nItemIndexX +(nItemIndexY*THUMB_ITEM_X);
											nItemRealIndex =  nItemIndexX +(nItemIndexY*THUMB_ITEM_X) + (nCurrentPage*THUMB_DISPLAY_MAX);	
											if(nItemIndex >= nCurrentPageCount) {
												nItemIndexX = nCurrentLineMax-1;
											}
											disp_sc_info_view( nItemRealIndex );

											SDL_Flip(screen);
											break;
					
					case SDLK_LEFT :	SDL_BlitSurface(bg, NULL, screen, NULL);
											
											nItemIndexX--;
											if(nItemIndexX < 0) {
												if (nItemIndexY) {
													nItemIndexY--;
													nItemIndexX=THUMB_ITEM_X -1;
												} else {
													nItemIndexX = 0;
													InitValue();
												}
											} else {            
											}
											disp_sc_info_view( nItemRealIndex );
											SDL_Flip(screen);
											break;
					case SDLK_RIGHT :	SDL_BlitSurface(bg, NULL, screen, NULL);

											nItemIndexX++; 
											if(nItemIndexX > 	widget_count-1) {
												nItemIndexX = 0;
												break;	
											}	
											if (nItemIndexX > THUMB_ITEM_X - 1) {
												nItemIndexX = 0;			
												nItemIndexY++;			
												nItemRealIndex =  nItemIndexX + (nItemIndexY*THUMB_ITEM_X) + (nCurrentPage*THUMB_DISPLAY_MAX);
												if(nItemRealIndex > widget_count-1) {
													nItemIndexY = 0;
													if(nCountOfPage > 1) {
														nCurrentPage++;		
														if(nCountOfPage < nCurrentPage+1) {
															nCurrentPage = 0;
														}
													}
												}else {				
													if (nItemIndexY > THUMB_ITEM_Y-1) {
														nItemIndexY = 0;
														if(nCountOfPage > 1) {
															nCurrentPage++;		
															if(nCountOfPage < nCurrentPage+1) {
																nCurrentPage = 0;
															}
														}
													}
												}
											} 

											disp_sc_info_view( nItemRealIndex );
											SDL_Flip(screen);
											break;
					case SDLK_RETURN:
					case SDLK_z		:	//CleanUp();
											SDL_BlitSurface(bg, NULL, screen, NULL);
											sdl_draw_text24(1920/4,20 , "SamyGO@TV");
											sdl_draw_text(1920/4,250 , "Starting Game...", 0);
											
											SDL_Flip(screen);
											sleep(2);
											nItemRealIndex =  nItemIndexX + (nItemIndexY*THUMB_ITEM_X) + (nCurrentPage*THUMB_DISPLAY_MAX);
											LoadGame(nItemRealIndex);
											sdl_init_all((char*) path );
											break;
					case SDLK_ESCAPE :
					case SDLK_POWER : 
					case SDL_QUIT  :	CleanUp();
			   							return 0;
											break;
				}
      	} 
      }
   }
	CleanUp();
	chdir(old_path);
   setenv("HOME", old_path, 1);
   return 0;
}

#ifndef ARM7

int main (int argc, char *argv[])
{
   char cur_path[256];
   if (getcwd(cur_path, sizeof(cur_path)) == NULL) strcpy(cur_path, "/");
   Game_Main(cur_path, "");
   return 0;
}

#endif

